"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.process = process;

var _cssMediaquery = require("css-mediaquery");

var _cssMediaquery2 = _interopRequireDefault(_cssMediaquery);

var _deepmerge = require("deepmerge");

var _deepmerge2 = _interopRequireDefault(_deepmerge);

var _microMemoize = require("micro-memoize");

var _microMemoize2 = _interopRequireDefault(_microMemoize);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PREFIX = "@media";

function isObject(obj) {
  return (typeof obj === "undefined" ? "undefined" : _typeof(obj)) === "object" && obj !== null;
}

function isMediaQuery(str) {
  return typeof str === "string" && str.indexOf(PREFIX) === 0;
}

function filterMq(obj) {
  return Object.keys(obj).filter(function (key) {
    return isMediaQuery(key);
  });
}

function filterNonMq(obj) {
  return Object.keys(obj).filter(function (key) {
    return !isMediaQuery(key);
  }).reduce(function (out, key) {
    out[key] = obj[key];
    return out;
  }, {});
}

var mMatch = (0, _microMemoize2.default)(_cssMediaquery2.default.match);
var mFilterMq = (0, _microMemoize2.default)(filterMq);
var mFilterNonMq = (0, _microMemoize2.default)(filterNonMq);

function process(obj, matchObject, Platform) {
  var mqKeys = mFilterMq(obj);
  var res = mFilterNonMq(obj);

  if (!mqKeys.length) {
    return res;
  }

  var newRes = void 0;

  mqKeys.forEach(function (key) {
    var mqStr = key.replace(PREFIX, "");

    if (/^@media\s+(ios|android)/i.test(key)) {
      matchObject.type = Platform.OS;
    }

    var isMatch = mMatch(mqStr, matchObject);
    if (isMatch) {
      newRes = (0, _deepmerge2.default)(res, obj[key]);
    }
  });

  return newRes;
}